************************************************************************
* File (cc_ff_1314_1516.F) created on Fri Jul  4 10:36:58 MSD 2008.
************************************************************************
* This is the FORTRAN module (cc_ff_1314_1516) to calculate 1-loop EW
* form factors for the up + dn -> mn + mo process.
*
* It is produced by s2n package of SANC (v1.10) Project.
* Copyright (C), SANC Project Team, 2002-2008.
*
* http://sanc.jinr.ru/
* http://pcphsanc.cern.ch/
* E-mail: <sanc@jinr.ru>
************************************************************************
      subroutine cc_ff_1314_1516 (qs,ts,us)
      implicit none!
#include "looptools.h"
#include "s2n_declare.h"

      complex*16 ff_qed_ll,ff_qed_ld,ff_qed_rd
      complex*16 ff_ew_ll,ff_ew_ld,ff_ew_rd

      real*8 a0fw,a0fz,a0fh,a0fmo
      complex*16 b0pmozmo,b0pmohmo,b0pmocw
      complex*16 b0fqswz,b0fqswh,b0fqswc,b0fmowc,b0fmozmo,b0fcwmo,b0fts
     & moc,b0ftscc,b0fmohmo,b0fqsmoc,b0fqscc
      complex*16 c0mocqswcz,c0mocqszmow,c0mocqshmow,c0mocqscmow,c0mocts
     & mozc,c0moctscwc,c0mocusmozc,c0ccqswcz,c0cctscwmo,c0cctsczc,c0ccus
     & cwmo,c0mocqsmozc,c0ccqsczc
      complex*16 b0d2mozmo
      complex*16 d0ccmocqstswczmo,d0ccmocqstszcwc,d0cccmoqsuswczc,d0ccc
     & moqsuszcwmo
      complex*16 javsubqstscmow,javsubqsuscmow
      real*8 sdet3icmoqs,sdet3icmots,sdet3icmous
      real*8 invfmow
      complex*16 propwqs,propiwqs

      common/unibos_bos/za1bos,zmzzzbos,zmwzwbos,zmhzhbos,deltarhobos
      common/unibos_fer/za1fer,zz1fer,zh1fer,zw1fer,zmsqrfer,
     & zmzzzfer,zmwzwfer,zmhzhfer,deltarhofer,tadfer
      common/unipro_fer/caldzfer,caldwfer,pizgfer,piggfer

      cmw2 = mw2

      propiwqs = (cmw2+qs)
      propwqs = 1d0/propiwqs
      a0fw = log(rwm2/thmu2) - 1d0
      a0fz = log(rzm2/thmu2) - 1d0
      a0fh = log(rhm2/thmu2) - 1d0
      a0fmo = log(rmom2/thmu2) - 1d0
      b0pmozmo = b0p(-rmom2,zm2,mom2)
      b0pmohmo = b0p(-rmom2,hm2,mom2)
      b0pmocw = b0p(-rmom2,cm2,wm2)
      b0fqswz = b0f(qs,thmu2,wm2,zm2)
      b0fqswh = b0f(qs,thmu2,wm2,hm2)
      b0fqswc = b0f(qs,thmu2,mw2,cm2)
      b0fmowc = b0f(-rmom2,thmu2,wm2,cm2)
      b0fmozmo = b0f(-rmom2,thmu2,zm2,mom2)
      b0fcwmo = b0f(0d0,thmu2,wm2,mom2)
      b0ftsmoc = b0f(ts,thmu2,mom2,cm2)
      b0ftscc = b0f(ts,thmu2,cm2,cm2)
      b0fmohmo = b0f(-rmom2,thmu2,hm2,mom2)
      b0fqsmoc = b0f(qs,thmu2,mom2,cm2)
      b0fqscc = b0f(qs,thmu2,cm2,cm2)
      c0mocqswcz = c01(-rmom2,1d-6,qs,wm2,cm2,zm2)
      c0mocqszmow = c01(-rmom2,1d-6,qs,zm2,mom2,wm2)
      c0mocqshmow = c01(-rmom2,1d-6,qs,hm2,mom2,wm2)
      c0mocqscmow = dreal(c01(-rmom2,0d0,qs,cm2,mom2,mw2))
      c0moctsmozc = c01(-rmom2,0d0,ts,mom2,zm2,cm2)
      c0moctscwc = c01(-rmom2,0d0,ts,cm2,wm2,cm2)
      c0mocusmozc = c01(-rmom2,0d0,us,mom2,zm2,cm2)
      c0ccqswcz = c01(0d0,0d0,qs,wm2,cm2,zm2)
      c0cctscwmo = c01(0d0,0d0,ts,cm2,wm2,mom2)
      c0cctsczc = c01(0d0,0d0,ts,cm2,zm2,cm2)
      c0ccuscwmo = c01(0d0,0d0,us,cm2,wm2,mom2)
      c0mocqsmozc = c01(-rmom2,0d0,qs,mom2,zm2,cm2)
      c0ccqsczc = c01(0d0,0d0,qs,cm2,zm2,cm2)
      b0d2mozmo = b0d2(-rmom2,thmu2,zm2,mom2)
      d0ccmocqstswczmo =
     & d0(0d0,0d0,rmom2,0d0,-qs,-ts,rwm2,0d0,rzm2,rmom2)
      d0ccmocqstszcwc =
     & d0(0d0,0d0,rmom2,0d0,-qs,-ts,rzm2,0d0,rwm2,0d0)
      d0cccmoqsuswczc =
     & d0(0d0,0d0,0d0,rmom2,-qs,-us,rwm2,0d0,rzm2,0d0)
      d0cccmoqsuszcwmo =
     & d0(0d0,0d0,0d0,rmom2,-qs,-us,rzm2,0d0,rwm2,rmom2)
      javsubqstscmow = javsub(qs,ts,cm2,mom2,mw2)
      javsubqsuscmow = javsub(qs,us,cm2,mom2,mw2)
      sdet3icmoqs = 1d0/(qs+(mmo)**2)
      sdet3icmots = 1d0/(ts+(mmo)**2)
      sdet3icmous = 1d0/(us+(mmo)**2)
      invfmow = 1d0/(1d0-rmom2/rwm2)

      ff_ew_ll =
     & +propwqs*a0fw*(-1d0/12/ctw**2*mw**2-5*mw**2+3*mw**4/mh**2-1d0/12*
     & mh**2)
     & +propwqs*a0fz*(1d0/12/ctw**4*mw**2+3d0/2/ctw**4*mw**4/mh**2+2d0/3
     & /ctw**2*mw**2-2*mw**2)
     & +propwqs*a0fh*(-1d0/12/qs*mh**4+1d0/2*mh**2)
     & +propwqs*b0fqswz*(1d0/12/ctw**4*mw**2+4d0/3/ctw**2*mw**2-4*ctw**2
     & *mw**2-17d0/3*mw**2)
     & +propwqs*b0fqswh*(-1d0/12/qs*mh**4+mw**2-1d0/3*mh**2)
     & +propwqs*b0fqswc*(4*ctw**2*mw**2-4*mw**2)
     & +propwqs*(1d0/ctw**4*mw**4/mh**2-1d0/6/ctw**2*mw**2-mw**2*zmwzwbo
     & s-64d0/9*mw**2+2*mw**4/mh**2-1d0/6*mh**2)
     & +propiwqs*sdet3icmoqs**2*c0mocqswcz*(1d0/ctw**4*vpaup*vpamn*ts*mw
     & **2+1d0/ctw**4*vpaup*vpamn*us*mw**2)
     & +propiwqs*sdet3icmoqs**2*c0mocqszmow*(1d0/ctw**2*vpadn*vpamo*ts*m
     & w**2-1d0/ctw**2*vpadn*vpamo*ts*mmo**2+1d0/ctw**2*vpadn*vpamo*us*m
     & w**2-1d0/ctw**2*vpadn*vpamo*us*mmo**2)
     & +propiwqs*sdet3icmoqs**2*c0mocqscmow*(-4*ctw**2*qdn*qmo*ts*mw**2+
     & 4*ctw**2*qdn*qmo*ts*mmo**2-4*ctw**2*qdn*qmo*us*mw**2+4*ctw**2*qdn
     & *qmo*us*mmo**2+4*qdn*qmo*ts*mw**2-4*qdn*qmo*ts*mmo**2+4*qdn*qmo*u
     & s*mw**2-4*qdn*qmo*us*mmo**2)
     & +propiwqs*sdet3icmoqs**2*b0fmowc*(-1d0/ctw**2*vpaup*vpamn*ts-1d0/
     & ctw**2*vpaup*vpamn*us)
     & +propiwqs*sdet3icmoqs**2*b0fmozmo*(-1d0/ctw**2*vpadn*vpamo*ts-1d0
     & /ctw**2*vpadn*vpamo*us)
     & +propiwqs*sdet3icmoqs**2*b0fqswz*(1d0/ctw**2*vpaup*vpamn*ts+1d0/c
     & tw**2*vpaup*vpamn*us+1d0/ctw**2*vpadn*vpamo*ts+1d0/ctw**2*vpadn*v
     & pamo*us)
     & +propiwqs*sdet3icmoqs**2*b0fqswc*(-4*ctw**2*qdn*qmo*ts-4*ctw**2*q
     & dn*qmo*us+4*qdn*qmo*ts+4*qdn*qmo*us)
     & +propiwqs*sdet3icmoqs**2*(4*ctw**2*qdn*qmo*ts+4*ctw**2*qdn*qmo*us
     & -4*qdn*qmo*ts-4*qdn*qmo*us)
     & +propiwqs*sdet3icmoqs*c0mocqswcz*(1d0/ctw**4*vpaup*vpamn/qs*mw**2
     & *mmo**2+2/ctw**4*vpaup*vpamn/ts*mw**2*mmo**2+2/ctw**4*vpaup*vpamn
     & /us*mw**2*mmo**2+2/ctw**4*vpaup*vpamn*mw**2-1d0/2/ctw**2*vpaup*vp
     & amn/qs*mw**2*mmo**2+1d0/2/ctw**2*vpaup*vpamn*ts+1d0/2/ctw**2*vpau
     & p*vpamn*us-1d0/2/ctw**2*vpaup*vpamn*mw**2)
     & +propiwqs*sdet3icmoqs*c0mocqszmow*(-1d0/2/ctw**4*vpadn*vpamo/qs*m
     & w**2*mmo**2-1d0/2/ctw**4*vpadn*vpamo*mw**2+1d0/ctw**2*vpadn*vpamo
     & /qs*mw**2*mmo**2+2/ctw**2*vpadn*vpamo/ts*mw**2*mmo**2-2/ctw**2*vp
     & adn*vpamo/ts*mmo**4+2/ctw**2*vpadn*vpamo/us*mw**2*mmo**2-2/ctw**2
     & *vpadn*vpamo/us*mmo**4+2/ctw**2*vpadn*vpamo*mw**2-1d0/ctw**2*vpad
     & n*vpamo*mmo**2)
     & +propiwqs*sdet3icmoqs*c0mocqscmow*(-4*ctw**2*qdn*qmo/qs*mw**2*mmo
     & **2-8*ctw**2*qdn*qmo/ts*mw**2*mmo**2+8*ctw**2*qdn*qmo/ts*mmo**4-8
     & *ctw**2*qdn*qmo/us*mw**2*mmo**2+8*ctw**2*qdn*qmo/us*mmo**4-8*ctw*
     & *2*qdn*qmo*mw**2+4*ctw**2*qdn*qmo*mmo**2+4*qdn*qmo/qs*mw**2*mmo**
     & 2+8*qdn*qmo/ts*mw**2*mmo**2-8*qdn*qmo/ts*mmo**4+8*qdn*qmo/us*mw**
     & 2*mmo**2-8*qdn*qmo/us*mmo**4+8*qdn*qmo*mw**2-4*qdn*qmo*mmo**2)
     & +propiwqs*sdet3icmoqs*a0fz*(-1d0/2/ctw**2*vpaup*vpamn/qs*mmo**2-1
     & d0/2/ctw**2*vpaup*vpamn)
     & +propiwqs*sdet3icmoqs*b0fmowc*(-1d0/ctw**2*vpaup*vpamn/qs*mmo**2-
     & 2/ctw**2*vpaup*vpamn/ts*mmo**2-2/ctw**2*vpaup*vpamn/us*mmo**2-2/c
     & tw**2*vpaup*vpamn)
     & +propiwqs*sdet3icmoqs*b0fmozmo*(-1d0/ctw**2*vpadn*vpamo/qs*mmo**2
     & -2/ctw**2*vpadn*vpamo/ts*mmo**2-2/ctw**2*vpadn*vpamo/us*mmo**2-2/
     & ctw**2*vpadn*vpamo)
     & +propiwqs*sdet3icmoqs*b0fqswz*(1d0/2/ctw**2*vpaup*vpamn/qs*mmo**2
     & +2/ctw**2*vpaup*vpamn/ts*mmo**2+2/ctw**2*vpaup*vpamn/us*mmo**2+3d
     & 0/2/ctw**2*vpaup*vpamn+1d0/2/ctw**2*vpadn*vpamo/qs*mmo**2+2/ctw**
     & 2*vpadn*vpamo/ts*mmo**2+2/ctw**2*vpadn*vpamo/us*mmo**2+3d0/2/ctw*
     & *2*vpadn*vpamo)
     & +propiwqs*sdet3icmoqs*b0fqswc*(-2*ctw**2*qdn*qmo/qs*mmo**2-8*ctw*
     & *2*qdn*qmo/ts*mmo**2-8*ctw**2*qdn*qmo/us*mmo**2-6*ctw**2*qdn*qmo+
     & 2*qdn*qmo/qs*mmo**2+8*qdn*qmo/ts*mmo**2+8*qdn*qmo/us*mmo**2+6*qdn
     & *qmo)
     & +propiwqs*sdet3icmoqs*b0fcwmo*(1d0/2/ctw**2*vpadn*vpamo/qs*mmo**2
     & +1d0/2/ctw**2*vpadn*vpamo-2*ctw**2*qdn*qmo/qs*mmo**2-2*ctw**2*qdn
     & *qmo+2*qdn*qmo/qs*mmo**2+2*qdn*qmo)
     & +propiwqs*sdet3icmoqs*(4*ctw**2*qdn*qmo/qs*mmo**2+8*ctw**2*qdn*qm
     & o/ts*mmo**2+8*ctw**2*qdn*qmo/us*mmo**2+8*ctw**2*qdn*qmo-4*qdn*qmo
     & /qs*mmo**2-8*qdn*qmo/ts*mmo**2-8*qdn*qmo/us*mmo**2-8*qdn*qmo)
     & +propiwqs*sdet3icmots*c0moctsmozc*(1d0/2/ctw**4*vpadn*vpamo/us*mw
     & **2*mmo**2)
     & +propiwqs*sdet3icmots*c0moctscwc*(1d0/2/ctw**2*vpaup*vpamn/us*mw*
     & *2*mmo**2)
     & +propiwqs*sdet3icmots*b0fmowc*(1d0/2/ctw**2*vpaup*vpamn/us*mmo**2
     & )
     & +propiwqs*sdet3icmots*b0fmozmo*(1d0/2/ctw**2*vpadn*vpamo/us*mmo**
     & 2)
     & +propiwqs*sdet3icmots*b0ftsmoc*(-1d0/2/ctw**2*vpadn*vpamo/us*mmo*
     & *2+2*ctw**2*qdn*qmo/us*mmo**2-2*qdn*qmo/us*mmo**2)
     & +propiwqs*sdet3icmots*b0ftscc*(-1d0/2/ctw**2*vpaup*vpamn/us*mmo**
     & 2)
     & +propiwqs*sdet3icmots*(-2*ctw**2*qdn*qmo/us*mmo**2+2*qdn*qmo/us*m
     & mo**2)
     & +propiwqs*d0ccmocqstswczmo*(1d0/4/ctw**6*vpadn*vpamo/qs/us**2*mw*
     & *4*mmo**4+1d0/4/ctw**6*vpadn*vpamo/qs/us*mw**4*mmo**2-1d0/4/ctw**
     & 6*vpadn*vpamo*ts/us**2*mw**4+1d0/4/ctw**6*vpadn*vpamo/us**2*mw**4
     & *mmo**2+1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**2*mmo**4-1d0/4/ctw**4*
     & vpadn*vpamo/qs/us*mw**4*mmo**2+1d0/4/ctw**4*vpadn*vpamo/qs*mw**2*
     & mmo**2+1d0/2/ctw**4*vpadn*vpamo*ts/us**2*mw**2*mmo**2-1d0/2/ctw**
     & 4*vpadn*vpamo*ts/us**2*mw**4+1d0/2/ctw**4*vpadn*vpamo*ts**2/us**2
     & *mw**2+1d0/2/ctw**4*vpadn*vpamo/us*mw**2*mmo**2-1d0/2/ctw**4*vpad
     & n*vpamo/us*mw**4-1d0/4/ctw**4*vpadn*vmamo/qs/us*mw**2*mmo**4-1d0/
     & 4/ctw**4*vpadn*vmamo/qs*mw**2*mmo**2-1d0/4/ctw**4*vpadn*vmamo/us*
     & mw**2*mmo**2-1d0/4/ctw**2*vpadn*vpamo/qs*mw**2*mmo**2+1d0/ctw**2*
     & vpadn*vpamo*ts/us**2*mw**2*mmo**2-1d0/4/ctw**2*vpadn*vpamo*ts/us*
     & *2*mw**4-3d0/4/ctw**2*vpadn*vpamo*ts/us**2*mmo**4-1d0/4/ctw**2*vp
     & adn*vpamo*ts/us*mmo**2-1d0/4/ctw**2*vpadn*vpamo*ts+1d0/2/ctw**2*v
     & padn*vpamo*ts**2/us**2*mw**2-3d0/4/ctw**2*vpadn*vpamo*ts**2/us**2
     & *mmo**2-1d0/4/ctw**2*vpadn*vpamo*ts**3/us**2+1d0/2/ctw**2*vpadn*v
     & pamo/us**2*mw**2*mmo**4-1d0/4/ctw**2*vpadn*vpamo/us**2*mw**4*mmo*
     & *2-1d0/4/ctw**2*vpadn*vpamo/us**2*mmo**6+1d0/4/ctw**2*vpadn*vpamo
     & /us*mw**2*mmo**2-1d0/4/ctw**2*vpadn*vpamo/us*mmo**4-1d0/4/ctw**2*
     & vpadn*vpamo*mmo**2+1d0/4/ctw**2*vpadn*vmamo/qs*mw**2*mmo**2+1d0/4
     & /ctw**2*vpadn*vmamo*ts/us*mmo**2-1d0/4/ctw**2*vpadn*vmamo/us*mw**
     & 2*mmo**2+1d0/4/ctw**2*vpadn*vmamo/us*mmo**4)
     & +propiwqs*d0ccmocqstszcwc*(-1d0/4/ctw**6*vpaup*vpamn*ts/us**2*mw*
     & *4-1d0/4/ctw**6*vpaup*vpamn/us**2*mw**4*mmo**2-1d0/4/ctw**4*vpaup
     & *vpamn/qs/us*mw**4*mmo**2-1d0/4/ctw**4*vpaup*vpamn/qs*mw**2*mmo**
     & 2+1d0/2/ctw**4*vpaup*vpamn*ts/us**2*mw**2*mmo**2-1d0/2/ctw**4*vpa
     & up*vpamn*ts/us**2*mw**4+1d0/2/ctw**4*vpaup*vpamn*ts**2/us**2*mw**
     & 2-1d0/2/ctw**4*vpaup*vpamn/us*mw**4+1d0/4/ctw**2*vpaup*vpamn/qs/u
     & s**2*mw**4*mmo**4+1d0/4/ctw**2*vpaup*vpamn/qs/us*mw**2*mmo**4+1d0
     & /4/ctw**2*vpaup*vpamn/qs/us*mw**4*mmo**2+1d0/4/ctw**2*vpaup*vpamn
     & /qs*mw**2*mmo**2-1d0/4/ctw**2*vpaup*vpamn*ts/us**2*mw**4-1d0/4/ct
     & w**2*vpaup*vpamn*ts+1d0/2/ctw**2*vpaup*vpamn*ts**2/us**2*mw**2-1d
     & 0/4/ctw**2*vpaup*vpamn*ts**2/us**2*mmo**2-1d0/4/ctw**2*vpaup*vpam
     & n*ts**3/us**2+1d0/4/ctw**2*vpaup*vpamn/us**2*mw**4*mmo**2+1d0/4/c
     & tw**2*vpaup*vpamn/us*mw**2*mmo**2)
     & +propiwqs*d0cccmoqsuswczc*(1d0/2/ctw**2*vpadn*vpamn*us)
     & +propiwqs*d0cccmoqsuszcwmo*(-1d0/4/ctw**4*vpaup*vmamo/qs*mw**2*mm
     & o**2+1d0/2/ctw**2*vpaup*vpamo*us+1d0/2/ctw**2*vpaup*vpamo*mmo**2+
     & 1d0/4/ctw**2*vpaup*vmamo/qs/us*mw**2*mmo**4+1d0/4/ctw**2*vpaup*vm
     & amo/qs*mw**2*mmo**2+1d0/4/ctw**2*vpaup*vmamo/us*mmo**4+1d0/4/ctw*
     & *2*vpaup*vmamo*mmo**2)
     & +propiwqs*c0mocqswcz*(-1d0/ctw**4*vpaup*vpamn/qs*mw**2+2/ctw**4*v
     & paup*vpamn/ts/us*mw**2*mmo**2-1d0/4/ctw**4*vpaup*vpamn*ts/us**2*m
     & w**2-1d0/4/ctw**4*vpaup*vpamn/us*mw**2+1d0/4/ctw**2*vpaup*vpamn/q
     & s/us**2*mw**2*mmo**4+1d0/4/ctw**2*vpaup*vpamn/qs/us*mmo**4+1d0/2/
     & ctw**2*vpaup*vpamn/qs*mw**2-1d0/4/ctw**2*vpaup*vpamn*ts/us**2*mw*
     & *2+1d0/4/ctw**2*vpaup*vpamn*ts**2/us**2+1d0/4/ctw**2*vpaup*vpamn/
     & us**2*mw**2*mmo**2-1d0/4/ctw**2*vpaup*vpamn/us*mw**2+1d0/4/ctw**2
     & *vpaup*vpamn/us*mmo**2+3d0/4/ctw**2*vpaup*vpamn-1d0/2/ctw**2*vpad
     & n*vpamn)
     & +propiwqs*c0mocqszmow*(1d0/4/ctw**4*vpadn*vpamo/qs/us**2*mw**2*mm
     & o**4+1d0/2/ctw**4*vpadn*vpamo/qs*mw**2-1d0/4/ctw**4*vpadn*vpamo*t
     & s/us**2*mw**2+1d0/4/ctw**4*vpadn*vpamo/us**2*mw**2*mmo**2-1d0/4/c
     & tw**4*vpadn*vpamo/us*mw**2-1d0/2/ctw**2*vpaup*vpamo+1d0/4/ctw**2*
     & vpaup*vmamo/qs/us*mmo**4+1d0/4/ctw**2*vpaup*vmamo/us*mmo**2+1d0/4
     & /ctw**2*vpadn*vpamo/qs/us*mmo**4-1d0/ctw**2*vpadn*vpamo/qs*mw**2+
     & 2/ctw**2*vpadn*vpamo/ts/us*mw**2*mmo**2-2/ctw**2*vpadn*vpamo/ts/u
     & s*mmo**4-1d0/4/ctw**2*vpadn*vpamo*ts/us**2*mw**2+1d0/4/ctw**2*vpa
     & dn*vpamo*ts/us**2*mmo**2+1d0/4/ctw**2*vpadn*vpamo*ts**2/us**2-1d0
     & /4/ctw**2*vpadn*vpamo/us*mw**2+1d0/2/ctw**2*vpadn*vpamo/us*mmo**2
     & +1d0/4/ctw**2*vpadn*vpamo-1d0/4/ctw**2*vpadn*vmamo/qs/us*mmo**4-1
     & d0/4/ctw**2*vpadn*vmamo/us*mmo**2)
     & +propiwqs*c0mocqscmow*(-ctw**2*qup*qmo/qs/us*mmo**4-ctw**2*qup*qm
     & o/us*mmo**2+2*ctw**2*qup*qmo+4*ctw**2*qdn*qmo/qs*mw**2-8*ctw**2*q
     & dn*qmo/ts/us*mw**2*mmo**2+8*ctw**2*qdn*qmo/ts/us*mmo**4+ctw**2*qd
     & n*qmo*ts/us**2*mw**2-ctw**2*qdn*qmo*ts/us**2*mmo**2-ctw**2*qdn*qm
     & o*ts**2/us**2+ctw**2*qdn*qmo/us*mw**2-ctw**2*qdn*qmo/us*mmo**2-ct
     & w**2*qdn*qmo+qup*qmo/qs/us*mmo**4+qup*qmo/us*mmo**2-2*qup*qmo-4*q
     & dn*qmo/qs*mw**2+8*qdn*qmo/ts/us*mw**2*mmo**2-8*qdn*qmo/ts/us*mmo*
     & *4-qdn*qmo*ts/us**2*mw**2+qdn*qmo*ts/us**2*mmo**2+qdn*qmo*ts**2/u
     & s**2-qdn*qmo/us*mw**2+qdn*qmo/us*mmo**2+qdn*qmo)
     & +propiwqs*c0moctsmozc*(1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**2*mmo**
     & 2+1d0/4/ctw**4*vpadn*vpamo*ts/us**2*mw**2+1d0/4/ctw**2*vpadn*vpam
     & o/qs*mmo**2+1d0/4/ctw**2*vpadn*vpamo*ts/us**2*mw**2-1d0/2/ctw**2*
     & vpadn*vpamo*ts/us**2*mmo**2+1d0/4/ctw**2*vpadn*vpamo*ts/us-1d0/4/
     & ctw**2*vpadn*vpamo*ts**2/us**2+1d0/4/ctw**2*vpadn*vpamo/us**2*mw*
     & *2*mmo**2-1d0/4/ctw**2*vpadn*vpamo/us**2*mmo**4-1d0/4/ctw**2*vpad
     & n*vmamo/qs*mmo**2+1d0/4/ctw**2*vpadn*vmamo/us*mmo**2)
     & +propiwqs*c0moctscwc*(1d0/4/ctw**4*vpaup*vpamn*ts/us**2*mw**2+1d0
     & /4/ctw**4*vpaup*vpamn/us**2*mw**2*mmo**2+1d0/4/ctw**2*vpaup*vpamn
     & /qs/us*mw**2*mmo**2+1d0/4/ctw**2*vpaup*vpamn/qs*mmo**2+1d0/4/ctw*
     & *2*vpaup*vpamn*ts/us**2*mw**2-1d0/4/ctw**2*vpaup*vpamn*ts/us**2*m
     & mo**2+1d0/4/ctw**2*vpaup*vpamn*ts/us-1d0/4/ctw**2*vpaup*vpamn*ts*
     & *2/us**2)
     & +propiwqs*c0mocusmozc*(-1d0/4/ctw**2*vpaup*vmamo/qs/us*mmo**4-1d0
     & /4/ctw**2*vpaup*vmamo/qs*mmo**2)
     & +propiwqs*c0ccqswcz*(-1d0/4/ctw**4*vpaup*vpamn*ts/us**2*mw**2-1d0
     & /4/ctw**4*vpaup*vpamn/us**2*mw**2*mmo**2-1d0/4/ctw**4*vpaup*vpamn
     & /us*mw**2-1d0/4/ctw**4*vpadn*vpamo*ts/us**2*mw**2-1d0/4/ctw**4*vp
     & adn*vpamo/us*mw**2-1d0/4/ctw**2*vpaup*vpamn*ts/us**2*mw**2+1d0/4/
     & ctw**2*vpaup*vpamn*ts/us**2*mmo**2+1d0/4/ctw**2*vpaup*vpamn*ts**2
     & /us**2-1d0/4/ctw**2*vpaup*vpamn/us*mw**2+1d0/4/ctw**2*vpaup*vpamn
     & -1d0/2/ctw**2*vpaup*vpamo-1d0/4/ctw**2*vpaup*vmamo/us*mmo**2-1d0/
     & 2/ctw**2*vpadn*vpamn-1d0/4/ctw**2*vpadn*vpamo*ts/us**2*mw**2+1d0/
     & 2/ctw**2*vpadn*vpamo*ts/us**2*mmo**2+1d0/4/ctw**2*vpadn*vpamo*ts*
     & *2/us**2-1d0/4/ctw**2*vpadn*vpamo/us**2*mw**2*mmo**2+1d0/4/ctw**2
     & *vpadn*vpamo/us**2*mmo**4-1d0/4/ctw**2*vpadn*vpamo/us*mw**2+1d0/4
     & /ctw**2*vpadn*vpamo/us*mmo**2+1d0/4/ctw**2*vpadn*vpamo-1d0/4/ctw*
     & *2*vpadn*vmamo/us*mmo**2)
     & +propiwqs*c0cctscwmo*(-1d0/4/ctw**4*vpadn*vpamo/qs/us**2*mw**2*mm
     & o**4-1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**2*mmo**2+1d0/4/ctw**4*vpa
     & dn*vpamo*ts/us**2*mw**2-1d0/4/ctw**4*vpadn*vpamo/us**2*mw**2*mmo*
     & *2-1d0/4/ctw**2*vpadn*vpamo/qs/us*mmo**4-1d0/4/ctw**2*vpadn*vpamo
     & /qs*mmo**2+1d0/4/ctw**2*vpadn*vpamo*ts/us**2*mw**2-1d0/4/ctw**2*v
     & padn*vpamo*ts/us**2*mmo**2+1d0/4/ctw**2*vpadn*vpamo*ts/us-1d0/4/c
     & tw**2*vpadn*vpamo*ts**2/us**2-1d0/4/ctw**2*vpadn*vpamo/us*mmo**2+
     & 1d0/4/ctw**2*vpadn*vmamo/qs/us*mmo**4+1d0/4/ctw**2*vpadn*vmamo/qs
     & *mmo**2+1d0/4/ctw**2*vpadn*vmamo/us*mmo**2-ctw**2*qdn*qmo*ts/us**
     & 2*mw**2+ctw**2*qdn*qmo*ts/us**2*mmo**2-ctw**2*qdn*qmo*ts/us+ctw**
     & 2*qdn*qmo*ts**2/us**2+qdn*qmo*ts/us**2*mw**2-qdn*qmo*ts/us**2*mmo
     & **2+qdn*qmo*ts/us-qdn*qmo*ts**2/us**2)
     & +propiwqs*c0cctsczc*(1d0/4/ctw**4*vpaup*vpamn*ts/us**2*mw**2-1d0/
     & 4/ctw**2*vpaup*vpamn/qs/us**2*mw**2*mmo**4-1d0/4/ctw**2*vpaup*vpa
     & mn/qs/us*mw**2*mmo**2-1d0/4/ctw**2*vpaup*vpamn/qs/us*mmo**4-1d0/4
     & /ctw**2*vpaup*vpamn/qs*mmo**2+1d0/4/ctw**2*vpaup*vpamn*ts/us**2*m
     & w**2+1d0/4/ctw**2*vpaup*vpamn*ts/us-1d0/4/ctw**2*vpaup*vpamn*ts**
     & 2/us**2-1d0/4/ctw**2*vpaup*vpamn/us**2*mw**2*mmo**2-1d0/4/ctw**2*
     & vpaup*vpamn/us*mmo**2)
     & +propiwqs*c0ccuscwmo*(1d0/4/ctw**2*vpaup*vmamo/qs*mmo**2-ctw**2*q
     & up*qmo/qs*mmo**2+qup*qmo/qs*mmo**2)
     & +propiwqs*a0fw*(3/qs*mw**2/mh**2-4/qs)
     & +propiwqs*a0fz*(3d0/2/ctw**4/qs*mw**2/mh**2+1d0/2/ctw**2*vpaup*vp
     & amn/qs)
     & +propiwqs*b0fmowc*(1d0/ctw**2*vpaup*vpamn/qs-2/ctw**2*vpaup*vpamn
     & /ts/us*mmo**2)
     & +propiwqs*b0fmozmo*(1d0/ctw**2*vpadn*vpamo/qs-2/ctw**2*vpadn*vpam
     & o/ts/us*mmo**2)
     & +propiwqs*b0fqswz*(-1d0/2/ctw**2*vpaup*vpamn/qs+2/ctw**2*vpaup*vp
     & amn/ts/us*mmo**2-1d0/2/ctw**2*vpaup*vpamn/us-1d0/2/ctw**2*vpadn*v
     & pamo/qs+2/ctw**2*vpadn*vpamo/ts/us*mmo**2-1d0/2/ctw**2*vpadn*vpam
     & o/us+5d0/6/ctw**2/qs-14d0/3*ctw**2/qs-53d0/12/qs)
     & +propiwqs*b0fqswh*(11d0/12/qs)
     & +propiwqs*b0fqswc*(2*ctw**2*qdn*qmo/qs-8*ctw**2*qdn*qmo/ts/us*mmo
     & **2+2*ctw**2*qdn*qmo/us+14d0/3*ctw**2/qs-2*qdn*qmo/qs+8*qdn*qmo/t
     & s/us*mmo**2-2*qdn*qmo/us-14d0/3/qs)
     & +propiwqs*b0ftsmoc*(1d0/2/ctw**2*vpadn*vpamo/us-2*ctw**2*qdn*qmo/
     & us+2*qdn*qmo/us)
     & +propiwqs*b0ftscc*(1d0/2/ctw**2*vpaup*vpamn/us)
     & +propiwqs*b0fcwmo*(-1d0/2/ctw**2*vpadn*vpamo/qs+2*ctw**2*qdn*qmo/
     & qs-2*qdn*qmo/qs)
     & +propiwqs*(1d0/ctw**4/qs*mw**2/mh**2-1d0/6/ctw**2/qs-4*ctw**2*qdn
     & *qmo/qs+8*ctw**2*qdn*qmo/ts/us*mmo**2+4*qdn*qmo/qs-8*qdn*qmo/ts/u
     & s*mmo**2+2/qs*mw**2/mh**2-64d0/9/qs)
     & +sdet3icmoqs**2*c0mocqswcz*(-1d0/ctw**4*vpamn*mw**4*mmo**2)
     & +sdet3icmoqs**2*c0mocqszmow*(1d0/4*vpamo/mw**2*mmo**8-7d0/4*vpamo
     & *mw**2*mmo**4+vpamo*mw**4*mmo**2+1d0/2*vpamo*mmo**6-1d0/4*vmamo/m
     & w**2*mmo**8-1d0/4*vmamo*mw**2*mmo**4+1d0/2*vmamo*mmo**6)
     & +sdet3icmoqs**2*c0mocqshmow*(-1d0/4/mw**2*mmo**8-1d0/4*mw**2*mmo*
     & *4+1d0/2*mmo**6)
     & +sdet3icmoqs**2*c0mocqsmozc*(1d0/2/ctw**6*vpamn*vpamo*mw**4*mmo**
     & 2)
     & +sdet3icmoqs**2*c0mocqscmow*(4*ctw**2*qmo*mw**2*mmo**4-2*ctw**2*q
     & mo*mw**4*mmo**2-2*ctw**2*qmo*mmo**6-4*qmo*mw**2*mmo**4+2*qmo*mw**
     & 4*mmo**2+2*qmo*mmo**6)
     & +sdet3icmoqs**2*b0fmowc*(1d0/ctw**2*vpamn*mw**2*mmo**2)
     & +sdet3icmoqs**2*b0fmozmo*(1d0/2/ctw**4*vpamn*vpamo*mw**2*mmo**2+1
     & d0/4*vpamo/mw**2*mmo**6-vpamo*mw**2*mmo**2+3d0/4*vpamo*mmo**4-1d0
     & /4*vmamo/mw**2*mmo**6+1d0/4*vmamo*mmo**4)
     & +sdet3icmoqs**2*b0fmohmo*(-1d0/4/mw**2*mmo**6+1d0/4*mmo**4)
     & +sdet3icmoqs**2*b0fqswz*(-1d0/ctw**2*vpamn*mw**2*mmo**2-1d0/4*vpa
     & mo/mw**2*mmo**6+vpamo*mw**2*mmo**2-3d0/4*vpamo*mmo**4+1d0/4*vmamo
     & /mw**2*mmo**6-1d0/4*vmamo*mmo**4)
     & +sdet3icmoqs**2*b0fqswh*(1d0/4/mw**2*mmo**6-1d0/4*mmo**4)
     & +sdet3icmoqs**2*b0fqswc*(-2*ctw**2*qmo*mw**2*mmo**2+2*ctw**2*qmo*
     & mmo**4+2*qmo*mw**2*mmo**2-2*qmo*mmo**4)
     & +sdet3icmoqs**2*b0fqsmoc*(-1d0/2/ctw**4*vpamn*vpamo*mw**2*mmo**2)
     & +sdet3icmoqs**2*(2*ctw**2*qmo*mw**2*mmo**2-2*ctw**2*qmo*mmo**4-2*
     & qmo*mw**2*mmo**2+2*qmo*mmo**4)
     & +sdet3icmoqs*c0mocqswcz*(1d0/2/ctw**4*vpamn*mw**2*mmo**2+1d0/ctw*
     & *2*vpamn*mw**4)
     & +sdet3icmoqs*c0mocqszmow*(3d0/4/ctw**2*vpamo*mw**2*mmo**2-1d0/ctw
     & **2*vpamo*mw**4+1d0/4/ctw**2*vpamo*mmo**4-1d0/4/ctw**2*vmamo*mw**
     & 2*mmo**2+1d0/4/ctw**2*vmamo*mmo**4-1d0/2*vpamo/mw**2*mmo**6+1d0/2
     & *vpamo*mw**2*mmo**2+1d0/2*vmamo/mw**2*mmo**6+1d0/2*vmamo*mw**2*mm
     & o**2-vmamo*mmo**4)
     & +sdet3icmoqs*c0mocqshmow*(-1d0/4/mw**2*mh**2*mmo**4+1d0/2/mw**2*m
     & mo**6-1d0/2*mw**2*mmo**2+1d0/4*mh**2*mmo**2)
     & +sdet3icmoqs*c0mocqsmozc*(-1d0/2/ctw**6*vpamn*vpamo*mw**4-1d0/2/c
     & tw**4*vpamn*vpamo*mw**2*mmo**2)
     & +sdet3icmoqs*c0mocqscmow*(-2*ctw**2*qmo*mw**2*mmo**2+2*ctw**2*qmo
     & *mmo**4+2*qmo*mw**2*mmo**2-2*qmo*mmo**4)
     & +sdet3icmoqs*a0fw*(ctw**2*qmo*mw**2-qmo*mw**2-1d0/2*vpamo*mw**2-1
     & d0/8*vpamo*mmo**2+1d0/8*vmamo*mmo**2+1d0/8*mmo**2)
     & +sdet3icmoqs*a0fz*(1d0/4/ctw**4*vpamn*vpamo*mw**2+1d0/2/ctw**2*vp
     & amn*mw**2)
     & +sdet3icmoqs*a0fmo*(1d0/8*vpamo/mw**2*mmo**4+1d0/2*vpamo*mmo**2-1
     & d0/8*vmamo/mw**2*mmo**4-1d0/8/mw**2*mmo**4)
     & +sdet3icmoqs*b0fmowc*(-1d0/2/ctw**2*vpamn*mmo**2-1d0/2*vpamn*mw**
     & 2-1d0/2*vpamn*mmo**2)
     & +sdet3icmoqs*b0fmozmo*(-1d0/4/ctw**4*vpamn*vpamo*mw**2-1d0/2/ctw*
     & *2*vpamn*vpamo*mmo**2+1d0/2/ctw**2*vpamo*mw**2+1d0/8/ctw**2*vpamo
     & *mmo**2+3d0/8/ctw**2*vmamo*mmo**2-1d0/4*vpamo/mw**2*mmo**4+1d0/2*
     & vpamo*mmo**2+1d0/4*vmamo/mw**2*mmo**4-1d0/2*vmamo*mmo**2)
     & +sdet3icmoqs*b0fmohmo*(-1d0/8/mw**2*mh**2*mmo**2+1d0/4/mw**2*mmo*
     & *4+1d0/2*mmo**2)
     & +sdet3icmoqs*b0fqswz*(1d0/2/ctw**2*vpamn*mw**2+1d0/2/ctw**2*vpamn
     & *mmo**2-1d0/2/ctw**2*vpamo*mw**2-1d0/8/ctw**2*vpamo*mmo**2-3d0/8/
     & ctw**2*vmamo*mmo**2+1d0/2*vpamn*mw**2+1d0/2*vpamn*mmo**2+3d0/8*vp
     & amo/mw**2*mmo**4-1d0/2*vpamo*mw**2-1d0/8*vpamo*mmo**2-3d0/8*vmamo
     & /mw**2*mmo**4+5d0/8*vmamo*mmo**2)
     & +sdet3icmoqs*b0fqswh*(1d0/8/mw**2*mh**2*mmo**2-3d0/8/mw**2*mmo**4
     & -3d0/8*mmo**2)
     & +sdet3icmoqs*b0fqswc*(ctw**2*qmo*mw**2-ctw**2*qmo*mmo**2-qmo*mw**
     & 2+qmo*mmo**2)
     & +sdet3icmoqs*b0fqsmoc*(1d0/2/ctw**4*vpamn*vpamo*mw**2+1d0/2/ctw**
     & 2*vpamn*vpamo*mmo**2)
     & +sdet3icmous*c0mocqscmow*(-ctw**2*qup*qmo/qs/us*mw**2*mmo**6-ctw*
     & *2*qup*qmo/qs*mw**2*mmo**4+ctw**2*qup*qmo*ts/us*mmo**4+ctw**2*qup
     & *qmo*ts*mmo**2-ctw**2*qup*qmo/us*mw**2*mmo**4-ctw**2*qup*qmo*mw**
     & 2*mmo**2+qup*qmo/qs/us*mw**2*mmo**6+qup*qmo/qs*mw**2*mmo**4-qup*q
     & mo*ts/us*mmo**4-qup*qmo*ts*mmo**2+qup*qmo/us*mw**2*mmo**4+qup*qmo
     & *mw**2*mmo**2)
     & +javsubqstscmow*(4*ctw**2*qdn*qmo*ts/us**2*mw**2*mmo**2-ctw**2*qd
     & n*qmo*ts/us**2*mw**4-3*ctw**2*qdn*qmo*ts/us**2*mmo**4-ctw**2*qdn*
     & qmo*ts+2*ctw**2*qdn*qmo*ts**2/us**2*mw**2-3*ctw**2*qdn*qmo*ts**2/
     & us**2*mmo**2-ctw**2*qdn*qmo*ts**3/us**2+2*ctw**2*qdn*qmo/us**2*mw
     & **2*mmo**4-ctw**2*qdn*qmo/us**2*mw**4*mmo**2-ctw**2*qdn*qmo/us**2
     & *mmo**6-ctw**2*qdn*qmo*mmo**2-4*qdn*qmo*ts/us**2*mw**2*mmo**2+qdn
     & *qmo*ts/us**2*mw**4+3*qdn*qmo*ts/us**2*mmo**4+qdn*qmo*ts-2*qdn*qm
     & o*ts**2/us**2*mw**2+3*qdn*qmo*ts**2/us**2*mmo**2+qdn*qmo*ts**3/us
     & **2-2*qdn*qmo/us**2*mw**2*mmo**4+qdn*qmo/us**2*mw**4*mmo**2+qdn*q
     & mo/us**2*mmo**6+qdn*qmo*mmo**2)
     & +javsubqsuscmow*(ctw**2*qup*qmo/qs/us*mw**2*mmo**4+ctw**2*qup*qmo
     & /qs*mw**2*mmo**2+ctw**2*qup*qmo/us*mmo**4+2*ctw**2*qup*qmo*us+3*c
     & tw**2*qup*qmo*mmo**2-qup*qmo/qs/us*mw**2*mmo**4-qup*qmo/qs*mw**2*
     & mmo**2-qup*qmo/us*mmo**4-2*qup*qmo*us-3*qup*qmo*mmo**2)
     & +c0mocqswcz*(-1d0/ctw**2*vpamn*mw**2-vpamn*mw**2+vpamn*mmo**2)
     & +c0mocqszmow*(1d0/ctw**2*vpamo*mw**2-1d0/2/ctw**2*vpamo*mmo**2+1d
     & 0/4*vpamo/mw**2*mmo**4+vpamo*mw**2-1d0/2*vpamo*mmo**2-1d0/4*vmamo
     & /mw**2*mmo**4+3d0/2*vmamo*mmo**2)
     & +c0mocqshmow*(-1d0/4/mw**2*mmo**4+1d0/2*mmo**2)
     & +c0mocqsmozc*(1d0/ctw**4*vpamn*vpamo*mw**2+1d0/2/ctw**2*vpamn*vpa
     & mo*ts+1d0/2/ctw**2*vpamn*vpamo*us)
     & +c0mocqscmow*(2*ctw**2*qup*qmo*ts+2*ctw**2*qup*qmo*us+ctw**2*qup*
     & qmo*mmo**2+2*ctw**2*qdn*qmo*ts/us**2*mw**2*mmo**2-ctw**2*qdn*qmo*
     & ts/us**2*mw**4-ctw**2*qdn*qmo*ts/us**2*mmo**4+2*ctw**2*qdn*qmo*ts
     & /us*mw**2-2*ctw**2*qdn*qmo*ts/us*mmo**2-ctw**2*qdn*qmo*ts+2*ctw**
     & 2*qdn*qmo*ts**2/us**2*mw**2-2*ctw**2*qdn*qmo*ts**2/us**2*mmo**2-c
     & tw**2*qdn*qmo*ts**2/us-ctw**2*qdn*qmo*ts**3/us**2+2*ctw**2*qdn*qm
     & o/us*mw**2*mmo**2-ctw**2*qdn*qmo/us*mw**4-ctw**2*qdn*qmo/us*mmo**
     & 4-ctw**2*qdn*qmo*us-2*ctw**2*qmo*mw**2-2*ctw**2*qmo*mmo**2-2*qup*
     & qmo*ts-2*qup*qmo*us-qup*qmo*mmo**2-2*qdn*qmo*ts/us**2*mw**2*mmo**
     & 2+qdn*qmo*ts/us**2*mw**4+qdn*qmo*ts/us**2*mmo**4-2*qdn*qmo*ts/us*
     & mw**2+2*qdn*qmo*ts/us*mmo**2+qdn*qmo*ts-2*qdn*qmo*ts**2/us**2*mw*
     & *2+2*qdn*qmo*ts**2/us**2*mmo**2+qdn*qmo*ts**2/us+qdn*qmo*ts**3/us
     & **2-2*qdn*qmo/us*mw**2*mmo**2+qdn*qmo/us*mw**4+qdn*qmo/us*mmo**4+
     & qdn*qmo*us+2*qmo*mw**2+2*qmo*mmo**2)
     & +c0ccqswcz*(1d0/ctw**2*vpaup/qs*mw**4-1d0/ctw**2*vpaup*mw**2-1d0/
     & ctw**2*vpadn/qs*mw**4+1d0/ctw**2*vpadn*mw**2-vpaup*mw**2+vpadn*mw
     & **2)
     & +c0ccqsczc*(-1d0/2/ctw**6*vpaup*vpadn/qs*mw**4+1d0/ctw**4*vpaup*v
     & padn*mw**2+1d0/2/ctw**2*vpaup*vpadn*ts+1d0/2/ctw**2*vpaup*vpadn*u
     & s+1d0/2/ctw**2*vpaup*vpadn*mmo**2)
     & +c0cctscwmo*(4*ctw**2*qdn*qmo*ts/us**2*mw**2*mmo**2-ctw**2*qdn*qm
     & o*ts/us**2*mw**4-3*ctw**2*qdn*qmo*ts/us**2*mmo**4-ctw**2*qdn*qmo*
     & ts+2*ctw**2*qdn*qmo*ts**2/us**2*mw**2-3*ctw**2*qdn*qmo*ts**2/us**
     & 2*mmo**2-ctw**2*qdn*qmo*ts**3/us**2+2*ctw**2*qdn*qmo/us**2*mw**2*
     & mmo**4-ctw**2*qdn*qmo/us**2*mw**4*mmo**2-ctw**2*qdn*qmo/us**2*mmo
     & **6-ctw**2*qdn*qmo*mmo**2-4*qdn*qmo*ts/us**2*mw**2*mmo**2+qdn*qmo
     & *ts/us**2*mw**4+3*qdn*qmo*ts/us**2*mmo**4+qdn*qmo*ts-2*qdn*qmo*ts
     & **2/us**2*mw**2+3*qdn*qmo*ts**2/us**2*mmo**2+qdn*qmo*ts**3/us**2-
     & 2*qdn*qmo/us**2*mw**2*mmo**4+qdn*qmo/us**2*mw**4*mmo**2+qdn*qmo/u
     & s**2*mmo**6+qdn*qmo*mmo**2)
     & +c0ccuscwmo*(ctw**2*qup*qmo/qs/us*mw**2*mmo**4+ctw**2*qup*qmo/qs*
     & mw**2*mmo**2+ctw**2*qup*qmo/us*mmo**4+2*ctw**2*qup*qmo*us+3*ctw**
     & 2*qup*qmo*mmo**2-qup*qmo/qs/us*mw**2*mmo**4-qup*qmo/qs*mw**2*mmo*
     & *2-qup*qmo/us*mmo**4-2*qup*qmo*us-3*qup*qmo*mmo**2)
     & +a0fw*(65d0/8+1d0/12/ctw**2/qs*mw**2-ctw**2*qup/qs*mw**2+2*ctw**2
     & *qup+ctw**2*qdn/qs*mw**2-2*ctw**2*qdn+qup/qs*mw**2-2*qup-qdn/qs*m
     & w**2+2*qdn+1d0/2*vpaup/qs*mw**2-vpaup-1d0/2*vpadn/qs*mw**2+vpadn+
     & 23d0/6/qs*mw**2-3/qs*mw**4/mh**2+1d0/12/qs*mh**2-3*mw**2/mh**2+7d
     & 0/8*invfmow-2*invfmow*ctw**2*qmo+2*invfmow*qmo+invfmow*vpamo-3d0/
     & 8*invfmow**2)
     & +a0fz*(1d0/2/ctw**4*vpaup*vpadn/qs*mw**2-1d0/12/ctw**4/qs*mw**2-3
     & d0/2/ctw**4/qs*mw**4/mh**2-3d0/2/ctw**4*mw**2/mh**2-1d0/ctw**2*vp
     & aup*vpadn+1d0/2/ctw**2*vpaup/qs*mw**2+1d0/8/ctw**2*vpaup**2-1d0/2
     & /ctw**2*vpadn/qs*mw**2+1d0/8/ctw**2*vpadn**2-1d0/2/ctw**2*vpamn*v
     & pamo+1d0/8/ctw**2*vpamn**2+1d0/8/ctw**2*vpamo*vmamo-1d0/16/ctw**2
     & *vpamo**2+1d0/16/ctw**2*vmamo**2-7d0/12/ctw**2/qs*mw**2-vpaup+vpa
     & dn-vpamn+2d0/3/qs*mw**2)
     & +a0fh*(1d0/12/qs*mh**2-1d0/16/mw**2*mh**2)
     & +a0fmo*(-3d0/8+1d0/4*stw**4*qmo**2/mw**2*mmo**2-1d0/8*vpamo*vmamo
     & /mw**2*mmo**2+1d0/16*vpamo**2/mw**2*mmo**2+3d0/16/mw**2*mmo**2+3d
     & 0/8*invfmow-invfmow*vpamo/mw**2*mmo**2-7d0/8*invfmow/mw**2*mmo**2
     & +3d0/8*invfmow**2/mw**2*mmo**2)
     & +b0fmowc*(-3d0/8+vpamn)
     & +b0fmozmo*(1d0/2/ctw**2*vpamn*vpamo+1d0/8/ctw**2*vpamo*vmamo-3d0/
     & 16/ctw**2*vpamo**2+1d0/16/ctw**2*vmamo**2-vpamo)
     & +b0fmohmo*(-1d0/16/mw**2*mh**2)
     & +b0fqswz*(13d0/3-1d0/12/ctw**4/qs*mw**2+1d0/2/ctw**2*vpaup/qs*mw*
     & *2-1d0/2/ctw**2*vpadn/qs*mw**2-4d0/3/ctw**2/qs*mw**2-5d0/6/ctw**2
     & +4*ctw**2/qs*mw**2+8*ctw**2+1d0/2*vpaup/qs*mw**2-1d0/2*vpaup-1d0/
     & 2*vpadn/qs*mw**2+1d0/2*vpadn-1d0/2*vpamn-1d0/8*vpamo/mw**2*mmo**2
     & +1d0/2*vpamo+1d0/8*vmamo/mw**2*mmo**2+17d0/3/qs*mw**2)
     & +b0fqswh*(-1-1d0/qs*mw**2+1d0/6/qs*mh**2+1d0/8/mw**2*mmo**2)
     & +b0fqswc*(8-ctw**2*qup/qs*mw**2+ctw**2*qup+ctw**2*qdn/qs*mw**2-ct
     & w**2*qdn-ctw**2*qmo-4*ctw**2/qs*mw**2-8*ctw**2+qup/qs*mw**2-qup-q
     & dn/qs*mw**2+qdn+qmo+4/qs*mw**2)
     & +b0fqsmoc*(-3d0/4/ctw**2*vpamn*vpamo)
     & +b0fqscc*(1d0/2/ctw**4*vpaup*vpadn/qs*mw**2-3d0/4/ctw**2*vpaup*vp
     & adn+3*ctw**2*qup*qdn-3*qup*qdn)
     & +110d0/9+1d0/stw**2*ctw**2*deltarhobos+1d0/stw**2*ctw**2*deltarho
     & fer-1d0/ctw**4/qs*mw**4/mh**2-1d0/ctw**4*mw**2/mh**2-1d0/2/ctw**2
     & *vpaup*vpadn+3d0/16/ctw**2*vpaup**2+3d0/16/ctw**2*vpadn**2-1d0/2/
     & ctw**2*vpamn*vpamo+3d0/16/ctw**2*vpamn**2+1d0/8/ctw**2*vpamo**2-1
     & d0/16/ctw**2*vmamo**2+1d0/6/ctw**2/qs*mw**2+1d0/6/ctw**2-2*ctw**2
     & *qup*qdn-2*ctw**2*qup+3d0/2*ctw**2*qup**2+2*ctw**2*qdn+3d0/2*ctw*
     & *2*qdn**2+2*ctw**2*qmo+3d0/2*ctw**2*qmo**2+2*qup*qdn+2*qup-3d0/2*
     & qup**2-2*qdn-3d0/2*qdn**2-2*qmo-3d0/2*qmo**2-1d0/8*vpamo/mw**2*mm
     & o**2+1d0/8*vmamo/mw**2*mmo**2+64d0/9/qs*mw**2-2/qs*mw**4/mh**2+1d
     & 0/16/mw**2*mmo**2-2*mw**2/mh**2-za1bos-za1fer+caldwfer-1d0/8*drea
     & l(b0pmozmo)/ctw**4*vpamo**2*mw**2-1d0/8*dreal(b0pmozmo)/ctw**4*vm
     & amo**2*mw**2-3d0/4*dreal(b0pmozmo)/ctw**2*vpamo*vmamo*mmo**2+1d0/
     & 8*dreal(b0pmozmo)/ctw**2*vpamo**2*mmo**2+1d0/8*dreal(b0pmozmo)/ct
     & w**2*vmamo**2*mmo**2-1d0/8*dreal(b0pmohmo)/mw**2*mh**2*mmo**2+1d0
     & /2*dreal(b0pmohmo)/mw**2*mmo**4+1d0/8*dreal(b0pmocw)/mw**2*mmo**4
     & -1d0/4*dreal(b0pmocw)*mw**2+1d0/8*dreal(b0pmocw)*mmo**2-1d0/8*b0d
     & 2mozmo/ctw**2*vmamo**2*mmo**2+3d0/8*invfmow

      ff_ew_ld =
     & +propiwqs*sdet3icmoqs*c0mocqswcz*(1d0/4/ctw**4*vpaup*vpamn/ts*mw*
     & *2*mmo-1d0/4/ctw**4*vpaup*vpamn/us*mw**2*mmo)
     & +propiwqs*sdet3icmoqs*c0mocqszmow*(1d0/4/ctw**2*vpadn*vpamo/ts*mw
     & **2*mmo-1d0/4/ctw**2*vpadn*vpamo/ts*mmo**3-1d0/4/ctw**2*vpadn*vpa
     & mo/us*mw**2*mmo+1d0/4/ctw**2*vpadn*vpamo/us*mmo**3)
     & +propiwqs*sdet3icmoqs*c0mocqscmow*(-ctw**2*qdn*qmo/ts*mw**2*mmo+c
     & tw**2*qdn*qmo/ts*mmo**3+ctw**2*qdn*qmo/us*mw**2*mmo-ctw**2*qdn*qm
     & o/us*mmo**3+qdn*qmo/ts*mw**2*mmo-qdn*qmo/ts*mmo**3-qdn*qmo/us*mw*
     & *2*mmo+qdn*qmo/us*mmo**3)
     & +propiwqs*sdet3icmoqs*b0fmowc*(-1d0/4/ctw**2*vpaup*vpamn/ts*mmo+1
     & d0/4/ctw**2*vpaup*vpamn/us*mmo)
     & +propiwqs*sdet3icmoqs*b0fmozmo*(-1d0/4/ctw**2*vpadn*vpamo/ts*mmo+
     & 1d0/4/ctw**2*vpadn*vpamo/us*mmo)
     & +propiwqs*sdet3icmoqs*b0fqswz*(1d0/4/ctw**2*vpaup*vpamn/ts*mmo-1d
     & 0/4/ctw**2*vpaup*vpamn/us*mmo+1d0/4/ctw**2*vpadn*vpamo/ts*mmo-1d0
     & /4/ctw**2*vpadn*vpamo/us*mmo)
     & +propiwqs*sdet3icmoqs*b0fqswc*(-ctw**2*qdn*qmo/ts*mmo+ctw**2*qdn*
     & qmo/us*mmo+qdn*qmo/ts*mmo-qdn*qmo/us*mmo)
     & +propiwqs*sdet3icmoqs*(ctw**2*qdn*qmo/ts*mmo-ctw**2*qdn*qmo/us*mm
     & o-qdn*qmo/ts*mmo+qdn*qmo/us*mmo)
     & +propiwqs*sdet3icmots*c0moctsmozc*(1d0/2/ctw**4*vpadn*vpamo/us*mw
     & **2*mmo)
     & +propiwqs*sdet3icmots*c0moctscwc*(1d0/2/ctw**2*vpaup*vpamn/us*mw*
     & *2*mmo)
     & +propiwqs*sdet3icmots*b0fmowc*(1d0/2/ctw**2*vpaup*vpamn/us*mmo)
     & +propiwqs*sdet3icmots*b0fmozmo*(1d0/2/ctw**2*vpadn*vpamo/us*mmo)
     & +propiwqs*sdet3icmots*b0ftsmoc*(-1d0/2/ctw**2*vpadn*vpamo/us*mmo+
     & 2*ctw**2*qdn*qmo/us*mmo-2*qdn*qmo/us*mmo)
     & +propiwqs*sdet3icmots*b0ftscc*(-1d0/2/ctw**2*vpaup*vpamn/us*mmo)
     & +propiwqs*sdet3icmots*(-2*ctw**2*qdn*qmo/us*mmo+2*qdn*qmo/us*mmo)
     & +propiwqs*d0ccmocqstswczmo*(1d0/4/ctw**6*vpadn*vpamo/qs/us**2*mw*
     & *4*mmo**3+1d0/4/ctw**6*vpadn*vpamo/qs/us*mw**4*mmo+1d0/4/ctw**6*v
     & padn*vpamo/us**2*mw**4*mmo+1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**2*m
     & mo**3-1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**4*mmo+1d0/4/ctw**4*vpadn
     & *vpamo/qs*mw**2*mmo-1d0/2/ctw**4*vpadn*vpamo*ts/us**2*mw**2*mmo-1
     & d0/2/ctw**4*vpadn*vpamo/us**2*mw**2*mmo**3+1d0/2/ctw**4*vpadn*vpa
     & mo/us**2*mw**4*mmo+1d0/4/ctw**4*vpadn*vpamo/us*mw**2*mmo-1d0/4/ct
     & w**4*vpadn*vmamo/qs/us*mw**2*mmo**3-1d0/4/ctw**4*vpadn*vmamo/qs*m
     & w**2*mmo-1d0/4/ctw**4*vpadn*vmamo/us*mw**2*mmo-1d0/4/ctw**2*vpadn
     & *vpamo/qs*mw**2*mmo-1d0/2/ctw**2*vpadn*vpamo/ts/us**2*mw**2*mmo**
     & 5+1d0/4/ctw**2*vpadn*vpamo/ts/us**2*mw**4*mmo**3+1d0/4/ctw**2*vpa
     & dn*vpamo/ts/us**2*mmo**7-1d0/4/ctw**2*vpadn*vpamo/ts/us*mw**2*mmo
     & **3+1d0/4/ctw**2*vpadn*vpamo/ts/us*mmo**5-1d0/2/ctw**2*vpadn*vpam
     & o*ts/us**2*mw**2*mmo+3d0/4/ctw**2*vpadn*vpamo*ts/us**2*mmo**3+1d0
     & /4/ctw**2*vpadn*vpamo*ts**2/us**2*mmo-1d0/ctw**2*vpadn*vpamo/us**
     & 2*mw**2*mmo**3+1d0/4/ctw**2*vpadn*vpamo/us**2*mw**4*mmo+3d0/4/ctw
     & **2*vpadn*vpamo/us**2*mmo**5+1d0/4/ctw**2*vpadn*vpamo/us*mmo**3+1
     & d0/4/ctw**2*vpadn*vmamo/qs*mw**2*mmo+1d0/4/ctw**2*vpadn*vmamo*ts/
     & us*mmo-1d0/4/ctw**2*vpadn*vmamo/us*mw**2*mmo+1d0/4/ctw**2*vpadn*v
     & mamo/us*mmo**3)
     & +propiwqs*d0ccmocqstszcwc*(1d0/4/ctw**6*vpaup*vpamn/ts/us**2*mw**
     & 4*mmo**3+1d0/4/ctw**6*vpaup*vpamn/us**2*mw**4*mmo-1d0/4/ctw**4*vp
     & aup*vpamn/qs/us*mw**4*mmo-1d0/4/ctw**4*vpaup*vpamn/qs*mw**2*mmo-1
     & d0/2/ctw**4*vpaup*vpamn*ts/us**2*mw**2*mmo-1d0/2/ctw**4*vpaup*vpa
     & mn/us**2*mw**2*mmo**3+1d0/2/ctw**4*vpaup*vpamn/us**2*mw**4*mmo+1d
     & 0/4/ctw**2*vpaup*vpamn/qs/us**2*mw**4*mmo**3+1d0/4/ctw**2*vpaup*v
     & pamn/qs/us*mw**2*mmo**3+1d0/4/ctw**2*vpaup*vpamn/qs/us*mw**4*mmo+
     & 1d0/4/ctw**2*vpaup*vpamn/qs*mw**2*mmo-1d0/2/ctw**2*vpaup*vpamn*ts
     & /us**2*mw**2*mmo+1d0/4/ctw**2*vpaup*vpamn*ts/us**2*mmo**3+1d0/4/c
     & tw**2*vpaup*vpamn*ts**2/us**2*mmo+1d0/4/ctw**2*vpaup*vpamn/us**2*
     & mw**4*mmo+1d0/4/ctw**2*vpaup*vpamn/us*mw**2*mmo)
     & +propiwqs*d0cccmoqsuszcwmo*(-1d0/4/ctw**4*vpaup*vmamo/qs*mw**2*mm
     & o+1d0/4/ctw**4*vpaup*vmamo/ts*mw**2*mmo+1d0/4/ctw**2*vpaup*vmamo/
     & qs/us*mw**2*mmo**3+1d0/4/ctw**2*vpaup*vmamo/qs*mw**2*mmo+1d0/4/ct
     & w**2*vpaup*vmamo/ts/us*mw**2*mmo**3-1d0/4/ctw**2*vpaup*vmamo/ts/u
     & s*mmo**5-1d0/4/ctw**2*vpaup*vmamo/ts*us*mmo+1d0/4/ctw**2*vpaup*vm
     & amo/ts*mw**2*mmo-1d0/2/ctw**2*vpaup*vmamo/ts*mmo**3)
     & +propiwqs*c0mocqswcz*(1d0/4/ctw**4*vpaup*vpamn/us**2*mw**2*mmo+1d
     & 0/4/ctw**2*vpaup*vpamn/qs/us**2*mw**2*mmo**3+1d0/4/ctw**2*vpaup*v
     & pamn/qs/us*mmo**3-1d0/4/ctw**2*vpaup*vpamn*ts/us**2*mmo+1d0/4/ctw
     & **2*vpaup*vpamn/us**2*mw**2*mmo)
     & +propiwqs*c0mocqszmow*(1d0/4/ctw**4*vpadn*vpamo/qs/us**2*mw**2*mm
     & o**3+1d0/4/ctw**4*vpadn*vpamo/us**2*mw**2*mmo+1d0/4/ctw**2*vpaup*
     & vmamo/qs/us*mmo**3+1d0/4/ctw**2*vpaup*vmamo/ts*mmo+1d0/4/ctw**2*v
     & padn*vpamo/qs/us*mmo**3-1d0/4/ctw**2*vpadn*vpamo*ts/us**2*mmo+1d0
     & /4/ctw**2*vpadn*vpamo/us**2*mw**2*mmo-1d0/4/ctw**2*vpadn*vpamo/us
     & **2*mmo**3-1d0/4/ctw**2*vpadn*vmamo/qs/us*mmo**3-1d0/4/ctw**2*vpa
     & dn*vmamo/us*mmo)
     & +propiwqs*c0mocqscmow*(-ctw**2*qup*qmo/qs/us*mmo**3-ctw**2*qup*qm
     & o/ts*mmo+ctw**2*qdn*qmo*ts/us**2*mmo-ctw**2*qdn*qmo/us**2*mw**2*m
     & mo+ctw**2*qdn*qmo/us**2*mmo**3+ctw**2*qdn*qmo/us*mmo+qup*qmo/qs/u
     & s*mmo**3+qup*qmo/ts*mmo-qdn*qmo*ts/us**2*mmo+qdn*qmo/us**2*mw**2*
     & mmo-qdn*qmo/us**2*mmo**3-qdn*qmo/us*mmo)
     & +propiwqs*c0moctsmozc*(1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**2*mmo-1
     & d0/4/ctw**4*vpadn*vpamo/us**2*mw**2*mmo+1d0/4/ctw**2*vpadn*vpamo/
     & qs*mmo-1d0/4/ctw**2*vpadn*vpamo/ts/us**2*mw**2*mmo**3+1d0/4/ctw**
     & 2*vpadn*vpamo/ts/us**2*mmo**5+1d0/4/ctw**2*vpadn*vpamo*ts/us**2*m
     & mo-1d0/4/ctw**2*vpadn*vpamo/us**2*mw**2*mmo+1d0/2/ctw**2*vpadn*vp
     & amo/us**2*mmo**3-1d0/4/ctw**2*vpadn*vpamo/us*mmo-1d0/4/ctw**2*vpa
     & dn*vmamo/qs*mmo+1d0/4/ctw**2*vpadn*vmamo/us*mmo)
     & +propiwqs*c0moctscwc*(-1d0/4/ctw**4*vpaup*vpamn/ts/us**2*mw**2*mm
     & o**3-1d0/4/ctw**4*vpaup*vpamn/us**2*mw**2*mmo+1d0/4/ctw**2*vpaup*
     & vpamn/qs/us*mw**2*mmo+1d0/4/ctw**2*vpaup*vpamn/qs*mmo+1d0/4/ctw**
     & 2*vpaup*vpamn*ts/us**2*mmo-1d0/4/ctw**2*vpaup*vpamn/us**2*mw**2*m
     & mo+1d0/4/ctw**2*vpaup*vpamn/us**2*mmo**3-1d0/4/ctw**2*vpaup*vpamn
     & /us*mmo)
     & +propiwqs*c0mocusmozc*(-1d0/4/ctw**2*vpaup*vmamo/qs/us*mmo**3-1d0
     & /4/ctw**2*vpaup*vmamo/qs*mmo-1d0/4/ctw**2*vpaup*vmamo/ts/us*mmo**
     & 3-1d0/4/ctw**2*vpaup*vmamo/ts*mmo)
     & +propiwqs*c0ccqswcz*(1d0/4/ctw**4*vpaup*vpamn/ts/us**2*mw**2*mmo*
     & *3+1d0/4/ctw**4*vpaup*vpamn/ts/us*mw**2*mmo+1d0/4/ctw**4*vpaup*vp
     & amn/us**2*mw**2*mmo+1d0/4/ctw**4*vpadn*vpamo/us**2*mw**2*mmo-1d0/
     & 4/ctw**2*vpaup*vpamn*ts/us**2*mmo+1d0/4/ctw**2*vpaup*vpamn/us**2*
     & mw**2*mmo-1d0/4/ctw**2*vpaup*vpamn/us**2*mmo**3+1d0/4/ctw**2*vpau
     & p*vmamo/ts/us*mmo**3+1d0/4/ctw**2*vpaup*vmamo/ts*mmo+1d0/4/ctw**2
     & *vpadn*vpamo/ts/us**2*mw**2*mmo**3-1d0/4/ctw**2*vpadn*vpamo/ts/us
     & **2*mmo**5+1d0/4/ctw**2*vpadn*vpamo/ts/us*mw**2*mmo-1d0/4/ctw**2*
     & vpadn*vpamo/ts/us*mmo**3-1d0/4/ctw**2*vpadn*vpamo*ts/us**2*mmo+1d
     & 0/4/ctw**2*vpadn*vpamo/us**2*mw**2*mmo-1d0/2/ctw**2*vpadn*vpamo/u
     & s**2*mmo**3-1d0/4/ctw**2*vpadn*vmamo/us*mmo)
     & +propiwqs*c0cctscwmo*(-1d0/4/ctw**4*vpadn*vpamo/qs/us**2*mw**2*mm
     & o**3-1d0/4/ctw**4*vpadn*vpamo/qs/us*mw**2*mmo-1d0/4/ctw**4*vpadn*
     & vpamo/us**2*mw**2*mmo-1d0/4/ctw**2*vpadn*vpamo/qs/us*mmo**3-1d0/4
     & /ctw**2*vpadn*vpamo/qs*mmo+1d0/4/ctw**2*vpadn*vpamo*ts/us**2*mmo-
     & 1d0/4/ctw**2*vpadn*vpamo/us**2*mw**2*mmo+1d0/4/ctw**2*vpadn*vpamo
     & /us**2*mmo**3-1d0/4/ctw**2*vpadn*vpamo/us*mmo+1d0/4/ctw**2*vpadn*
     & vmamo/qs/us*mmo**3+1d0/4/ctw**2*vpadn*vmamo/qs*mmo+1d0/4/ctw**2*v
     & padn*vmamo/us*mmo-ctw**2*qdn*qmo*ts/us**2*mmo+ctw**2*qdn*qmo/us**
     & 2*mw**2*mmo-ctw**2*qdn*qmo/us**2*mmo**3+qdn*qmo*ts/us**2*mmo-qdn*
     & qmo/us**2*mw**2*mmo+qdn*qmo/us**2*mmo**3)
     & +propiwqs*c0cctsczc*(-1d0/4/ctw**4*vpaup*vpamn/us**2*mw**2*mmo-1d
     & 0/4/ctw**2*vpaup*vpamn/qs/us**2*mw**2*mmo**3-1d0/4/ctw**2*vpaup*v
     & pamn/qs/us*mw**2*mmo-1d0/4/ctw**2*vpaup*vpamn/qs/us*mmo**3-1d0/4/
     & ctw**2*vpaup*vpamn/qs*mmo+1d0/4/ctw**2*vpaup*vpamn*ts/us**2*mmo-1
     & d0/4/ctw**2*vpaup*vpamn/us**2*mw**2*mmo-1d0/4/ctw**2*vpaup*vpamn/
     & us*mmo)
     & +propiwqs*c0ccuscwmo*(1d0/4/ctw**2*vpaup*vmamo/qs*mmo-1d0/4/ctw**
     & 2*vpaup*vmamo/ts*mmo-ctw**2*qup*qmo/qs*mmo+ctw**2*qup*qmo/ts*mmo+
     & qup*qmo/qs*mmo-qup*qmo/ts*mmo)
     & +propiwqs*b0fmowc*(-1d0/4/ctw**2*vpaup*vpamn/ts/us*mmo)
     & +propiwqs*b0fmozmo*(-1d0/4/ctw**2*vpadn*vpamo/ts/us*mmo)
     & +propiwqs*b0fqswz*(1d0/4/ctw**2*vpaup*vpamn/ts/us*mmo+1d0/4/ctw**
     & 2*vpadn*vpamo/ts/us*mmo)
     & +propiwqs*b0fqswc*(-ctw**2*qdn*qmo/ts/us*mmo+qdn*qmo/ts/us*mmo)
     & +propiwqs*(ctw**2*qdn*qmo/ts/us*mmo-qdn*qmo/ts/us*mmo)
     & +sdet3icmoqs**3*c0mocqswcz*(-3/ctw**4*vpamn*mw**4*mmo**3)
     & +sdet3icmoqs**3*c0mocqszmow*(3d0/4*vpamo/mw**2*mmo**9-21d0/4*vpam
     & o*mw**2*mmo**5+3*vpamo*mw**4*mmo**3+3d0/2*vpamo*mmo**7-3d0/4*vmam
     & o/mw**2*mmo**9-3d0/4*vmamo*mw**2*mmo**5+3d0/2*vmamo*mmo**7)
     & +sdet3icmoqs**3*c0mocqshmow*(-3d0/4/mw**2*mmo**9-3d0/4*mw**2*mmo*
     & *5+3d0/2*mmo**7)
     & +sdet3icmoqs**3*c0mocqsmozc*(3d0/2/ctw**6*vpamn*vpamo*mw**4*mmo**
     & 3)
     & +sdet3icmoqs**3*c0mocqscmow*(12*ctw**2*qmo*mw**2*mmo**5-6*ctw**2*
     & qmo*mw**4*mmo**3-6*ctw**2*qmo*mmo**7-12*qmo*mw**2*mmo**5+6*qmo*mw
     & **4*mmo**3+6*qmo*mmo**7)
     & +sdet3icmoqs**3*b0fmowc*(3/ctw**2*vpamn*mw**2*mmo**3)
     & +sdet3icmoqs**3*b0fmozmo*(3d0/2/ctw**4*vpamn*vpamo*mw**2*mmo**3+3
     & d0/4*vpamo/mw**2*mmo**7-3*vpamo*mw**2*mmo**3+9d0/4*vpamo*mmo**5-3
     & d0/4*vmamo/mw**2*mmo**7+3d0/4*vmamo*mmo**5)
     & +sdet3icmoqs**3*b0fmohmo*(-3d0/4/mw**2*mmo**7+3d0/4*mmo**5)
     & +sdet3icmoqs**3*b0fqswz*(-3/ctw**2*vpamn*mw**2*mmo**3-3d0/4*vpamo
     & /mw**2*mmo**7+3*vpamo*mw**2*mmo**3-9d0/4*vpamo*mmo**5+3d0/4*vmamo
     & /mw**2*mmo**7-3d0/4*vmamo*mmo**5)
     & +sdet3icmoqs**3*b0fqswh*(3d0/4/mw**2*mmo**7-3d0/4*mmo**5)
     & +sdet3icmoqs**3*b0fqswc*(-6*ctw**2*qmo*mw**2*mmo**3+6*ctw**2*qmo*
     & mmo**5+6*qmo*mw**2*mmo**3-6*qmo*mmo**5)
     & +sdet3icmoqs**3*b0fqsmoc*(-3d0/2/ctw**4*vpamn*vpamo*mw**2*mmo**3)
     & +sdet3icmoqs**3*(6*ctw**2*qmo*mw**2*mmo**3-6*ctw**2*qmo*mmo**5-6*
     & qmo*mw**2*mmo**3+6*qmo*mmo**5)
     & +sdet3icmoqs**2*c0mocqswcz*(1d0/ctw**4*vpamn*mw**2*mmo**3+1d0/ctw
     & **4*vpamn*mw**4*mmo-2/ctw**2*vpamn*mw**2*mmo**3+2/ctw**2*vpamn*mw
     & **4*mmo)
     & +sdet3icmoqs**2*c0mocqszmow*(3d0/2/ctw**2*vpamo*mw**2*mmo**3-2/ct
     & w**2*vpamo*mw**4*mmo+1d0/2/ctw**2*vpamo*mmo**5+1d0/2/ctw**2*vmamo
     & *mw**2*mmo**3-1d0/2/ctw**2*vmamo*mmo**5-7d0/4*vpamo/mw**2*mmo**7+
     & 19d0/4*vpamo*mw**2*mmo**3-vpamo*mw**4*mmo-2*vpamo*mmo**5+7d0/4*vm
     & amo/mw**2*mmo**7+13d0/4*vmamo*mw**2*mmo**3-5*vmamo*mmo**5)
     & +sdet3icmoqs**2*c0mocqshmow*(-1d0/2/mw**2*mh**2*mmo**5+3d0/4/mw**
     & 2*mmo**7-3d0/4*mw**2*mmo**3+1d0/2*mh**2*mmo**3)
     & +sdet3icmoqs**2*c0mocqsmozc*(-3d0/2/ctw**6*vpamn*vpamo*mw**4*mmo-
     & 1d0/ctw**4*vpamn*vpamo*mw**2*mmo**3+1d0/ctw**4*vpamn*vmamo*mw**2*
     & mmo**3)
     & +sdet3icmoqs**2*c0mocqscmow*(-16*ctw**2*qmo*mw**2*mmo**3+2*ctw**2
     & *qmo*mw**4*mmo+14*ctw**2*qmo*mmo**5+16*qmo*mw**2*mmo**3-2*qmo*mw*
     & *4*mmo-14*qmo*mmo**5)
     & +sdet3icmoqs**2*a0fw*(3*ctw**2*qmo*mw**2*mmo-3*qmo*mw**2*mmo-3d0/
     & 2*vpamo*mw**2*mmo-3d0/8*vpamo*mmo**3+3d0/8*vmamo*mmo**3+3d0/8*mmo
     & **3)
     & +sdet3icmoqs**2*a0fz*(3d0/4/ctw**4*vpamn*vpamo*mw**2*mmo+3d0/2/ct
     & w**2*vpamn*mw**2*mmo)
     & +sdet3icmoqs**2*a0fmo*(3d0/8*vpamo/mw**2*mmo**5+3d0/2*vpamo*mmo**
     & 3-3d0/8*vmamo/mw**2*mmo**5-3d0/8/mw**2*mmo**5)
     & +sdet3icmoqs**2*b0fmowc*(-1d0/ctw**2*vpamn*mw**2*mmo-1d0/ctw**2*v
     & pamn*mmo**3-1d0/2*vpamn*mw**2*mmo+1d0/2*vpamn*mmo**3)
     & +sdet3icmoqs**2*b0fmozmo*(-3d0/4/ctw**4*vpamn*vpamo*mw**2*mmo-1d0
     & /ctw**2*vpamn*vpamo*mmo**3+1d0/ctw**2*vpamn*vmamo*mmo**3+1d0/2/ct
     & w**2*vpamo*mw**2*mmo+1d0/8/ctw**2*vpamo*mmo**3-1d0/8/ctw**2*vmamo
     & *mmo**3-vpamo/mw**2*mmo**5+vpamo*mw**2*mmo-3d0/4*vpamo*mmo**3+vma
     & mo/mw**2*mmo**5-13d0/4*vmamo*mmo**3)
     & +sdet3icmoqs**2*b0fmohmo*(-1d0/8/mw**2*mh**2*mmo**3+3d0/4*mmo**3)
     & +sdet3icmoqs**2*b0fqswz*(5d0/2/ctw**2*vpamn*mw**2*mmo+1d0/ctw**2*
     & vpamn*mmo**3-1d0/2/ctw**2*vpamo*mw**2*mmo-1d0/8/ctw**2*vpamo*mmo*
     & *3+1d0/8/ctw**2*vmamo*mmo**3+1d0/2*vpamn*mw**2*mmo-1d0/2*vpamn*mm
     & o**3+11d0/8*vpamo/mw**2*mmo**5-5d0/2*vpamo*mw**2*mmo+15d0/8*vpamo
     & *mmo**3-11d0/8*vmamo/mw**2*mmo**5+29d0/8*vmamo*mmo**3)
     & +sdet3icmoqs**2*b0fqswh*(1d0/8/mw**2*mh**2*mmo**3-3d0/8/mw**2*mmo
     & **5-3d0/8*mmo**3)
     & +sdet3icmoqs**2*b0fqswc*(5*ctw**2*qmo*mw**2*mmo-11*ctw**2*qmo*mmo
     & **3-5*qmo*mw**2*mmo+11*qmo*mmo**3)
     & +sdet3icmoqs**2*b0fqsmoc*(3d0/2/ctw**4*vpamn*vpamo*mw**2*mmo+1d0/
     & ctw**2*vpamn*vpamo*mmo**3-1d0/ctw**2*vpamn*vmamo*mmo**3)
     & +sdet3icmoqs**2*(-2*ctw**2*qmo*mw**2*mmo+8*ctw**2*qmo*mmo**3+2*qm
     & o*mw**2*mmo-8*qmo*mmo**3)
     & +sdet3icmoqs*c0mocqswcz*(-1d0/2/ctw**2*vpamn*mw**2*mmo+1d0/2/ctw*
     & *2*vpamn*mmo**3)
     & +sdet3icmoqs*c0mocqszmow*(1d0/2/ctw**2*vpamo*mw**2*mmo-1d0/4/ctw*
     & *2*vpamo*mmo**3-2/ctw**2*vmamo*mw**2*mmo+3d0/4/ctw**2*vmamo*mmo**
     & 3+5d0/4*vpamo/mw**2*mmo**5-1d0/2*vpamo*mmo**3-5d0/4*vmamo/mw**2*m
     & mo**5-vmamo*mw**2*mmo+9d0/2*vmamo*mmo**3)
     & +sdet3icmoqs*c0mocqshmow*(-1d0/4/mw**2*mh**2*mmo**3+1d0/4/mw**2*m
     & mo**5+1d0/2*mh**2*mmo-mmo**3)
     & +sdet3icmoqs*c0mocqsmozc*(2/ctw**4*vpamn*vpamo*mw**2*mmo-1d0/ctw*
     & *4*vpamn*vmamo*mw**2*mmo)
     & +sdet3icmoqs*c0mocqscmow*(2*ctw**2*qmo*mw**2*mmo-8*ctw**2*qmo*mmo
     & **3-2*qmo*mw**2*mmo+8*qmo*mmo**3)
     & +sdet3icmoqs*a0fw*(-1d0/2*vpamn*mw**2/mmo+1d0/4*vpamo*mmo-1d0/4*v
     & mamo*mmo+1d0/4*mmo+2*invfmow*ctw**2*qmo*mmo-2*invfmow*qmo*mmo+1d0
     & /4*invfmow*vpamo*mmo-5d0/4*invfmow*vmamo*mmo+1d0/4*invfmow*mmo)
     & +sdet3icmoqs*a0fz*(-1d0/4/ctw**4*vpamn*vpamo*mw**2/mmo-1d0/2/ctw*
     & *2*vpamn*vpamo*mmo+1d0/2/ctw**2*vpamn*vmamo*mmo-1d0/2/ctw**2*vpam
     & n*mmo+1d0/2/ctw**2*vpamo*mw**2/mmo+1d0/8/ctw**2*vpamo*mmo-1d0/8/c
     & tw**2*vmamo*mmo)
     & +sdet3icmoqs*a0fh*(-1d0/8/mw**2*mh**2*mmo)
     & +sdet3icmoqs*a0fmo*(1d0/4/ctw**2*vpamn*vpamo*mmo-3d0/8*vpamo/mw**
     & 2*mmo**3-1d0/2*vpamo*mmo+3d0/8*vmamo/mw**2*mmo**3-1d0/8/mw**2*mmo
     & **3-1d0/4*invfmow*vpamo/mw**2*mmo**3+5d0/4*invfmow*vmamo/mw**2*mm
     & o**3-1d0/4*invfmow/mw**2*mmo**3)
     & +sdet3icmoqs*b0fmowc*(-1d0/2*vpamn*mw**2/mmo+1d0/2*vpamn*mmo)
     & +sdet3icmoqs*b0fmozmo*(-1d0/4/ctw**4*vpamn*vpamo*mw**2/mmo+1d0/ct
     & w**2*vpamn*vpamo*mmo-1d0/2/ctw**2*vpamn*vmamo*mmo+1d0/2/ctw**2*vp
     & amo*mw**2/mmo+1d0/8/ctw**2*vpamo*mmo+3d0/8/ctw**2*vmamo*mmo+1d0/4
     & *vpamo/mw**2*mmo**3-vpamo*mmo-1d0/4*vmamo/mw**2*mmo**3+vmamo*mmo)
     & 
     & +sdet3icmoqs*b0fmohmo*(-1d0/8/mw**2*mh**2*mmo+1d0/4/mw**2*mmo**3)
     & +sdet3icmoqs*b0fqswz*(-1d0/2/ctw**2*vpamn*mmo-1d0/2/ctw**2*vmamo*
     & mmo-1d0/2*vpamn*mmo-5d0/8*vpamo/mw**2*mmo**3+vpamo*mmo+5d0/8*vmam
     & o/mw**2*mmo**3-5d0/2*vmamo*mmo)
     & +sdet3icmoqs*b0fqswh*(-3d0/8/mw**2*mmo**3+1d0/2*mmo)
     & +sdet3icmoqs*b0fqswc*(3*ctw**2*qmo*mmo-3*qmo*mmo)
     & +sdet3icmoqs*b0fqsmoc*(-5d0/4/ctw**2*vpamn*vpamo*mmo+1d0/ctw**2*v
     & pamn*vmamo*mmo)
     & +sdet3icmoqs*(-1d0/4/ctw**2*vpamn*vpamo*mmo+ctw**2*qmo*mmo-qmo*mm
     & o+1d0/2*vpamn*mmo-1d0/8*vpamo/mw**2*mmo**3-1d0/2*vpamo*mmo+1d0/8*
     & vmamo/mw**2*mmo**3+1d0/8/mw**2*mmo**3)
     & +sdet3icmots*c0mocqscmow*(-2*ctw**2*qdn*qmo/ts/us*mw**2*mmo**5+ct
     & w**2*qdn*qmo/ts/us*mw**4*mmo**3+ctw**2*qdn*qmo/ts/us*mmo**7-ctw**
     & 2*qdn*qmo/ts*mw**2*mmo**3+ctw**2*qdn*qmo/ts*mmo**5-2*ctw**2*qdn*q
     & mo/us*mw**2*mmo**3+ctw**2*qdn*qmo/us*mw**4*mmo+ctw**2*qdn*qmo/us*
     & mmo**5-ctw**2*qdn*qmo*mw**2*mmo+ctw**2*qdn*qmo*mmo**3+2*qdn*qmo/t
     & s/us*mw**2*mmo**5-qdn*qmo/ts/us*mw**4*mmo**3-qdn*qmo/ts/us*mmo**7
     & +qdn*qmo/ts*mw**2*mmo**3-qdn*qmo/ts*mmo**5+2*qdn*qmo/us*mw**2*mmo
     & **3-qdn*qmo/us*mw**4*mmo-qdn*qmo/us*mmo**5+qdn*qmo*mw**2*mmo-qdn*
     & qmo*mmo**3)
     & +sdet3icmous*c0mocqscmow*(-ctw**2*qup*qmo/qs/us*mw**2*mmo**5-ctw*
     & *2*qup*qmo/qs*mw**2*mmo**3-ctw**2*qup*qmo/us*mmo**5-ctw**2*qup*qm
     & o*mmo**3+qup*qmo/qs/us*mw**2*mmo**5+qup*qmo/qs*mw**2*mmo**3+qup*q
     & mo/us*mmo**5+qup*qmo*mmo**3)
     & +javsubqstscmow*(-2*ctw**2*qdn*qmo/ts/us**2*mw**2*mmo**5+ctw**2*q
     & dn*qmo/ts/us**2*mw**4*mmo**3+ctw**2*qdn*qmo/ts/us**2*mmo**7-ctw**
     & 2*qdn*qmo/ts/us*mw**2*mmo**3+ctw**2*qdn*qmo/ts/us*mmo**5-2*ctw**2
     & *qdn*qmo*ts/us**2*mw**2*mmo+3*ctw**2*qdn*qmo*ts/us**2*mmo**3+ctw*
     & *2*qdn*qmo*ts/us*mmo+ctw**2*qdn*qmo*ts**2/us**2*mmo-4*ctw**2*qdn*
     & qmo/us**2*mw**2*mmo**3+ctw**2*qdn*qmo/us**2*mw**4*mmo+3*ctw**2*qd
     & n*qmo/us**2*mmo**5-ctw**2*qdn*qmo/us*mw**2*mmo+2*ctw**2*qdn*qmo/u
     & s*mmo**3+2*qdn*qmo/ts/us**2*mw**2*mmo**5-qdn*qmo/ts/us**2*mw**4*m
     & mo**3-qdn*qmo/ts/us**2*mmo**7+qdn*qmo/ts/us*mw**2*mmo**3-qdn*qmo/
     & ts/us*mmo**5+2*qdn*qmo*ts/us**2*mw**2*mmo-3*qdn*qmo*ts/us**2*mmo*
     & *3-qdn*qmo*ts/us*mmo-qdn*qmo*ts**2/us**2*mmo+4*qdn*qmo/us**2*mw**
     & 2*mmo**3-qdn*qmo/us**2*mw**4*mmo-3*qdn*qmo/us**2*mmo**5+qdn*qmo/u
     & s*mw**2*mmo-2*qdn*qmo/us*mmo**3)
     & +javsubqsuscmow*(ctw**2*qup*qmo/qs/us*mw**2*mmo**3+ctw**2*qup*qmo
     & /qs*mw**2*mmo+ctw**2*qup*qmo/ts/us*mw**2*mmo**3-ctw**2*qup*qmo/ts
     & /us*mmo**5-ctw**2*qup*qmo/ts*us*mmo+ctw**2*qup*qmo/ts*mw**2*mmo-2
     & *ctw**2*qup*qmo/ts*mmo**3-qup*qmo/qs/us*mw**2*mmo**3-qup*qmo/qs*m
     & w**2*mmo-qup*qmo/ts/us*mw**2*mmo**3+qup*qmo/ts/us*mmo**5+qup*qmo/
     & ts*us*mmo-qup*qmo/ts*mw**2*mmo+2*qup*qmo/ts*mmo**3)
     & +c0mocqszmow*(-1d0/4*vpamo/mw**2*mmo**3+1d0/4*vmamo/mw**2*mmo**3)
     & +c0mocqshmow*(-1d0/4/mw**2*mmo**3)
     & +c0mocqsmozc*(-1d0/2/ctw**2*vpamn*vpamo*mmo+1d0/2/ctw**2*vpamn*vm
     & amo*mmo)
     & +c0mocqscmow*(-ctw**2*qup*qmo/ts*us*mmo+ctw**2*qup*qmo/ts*mw**2*m
     & mo-ctw**2*qup*qmo/ts*mmo**3-ctw**2*qup*qmo*mmo-2*ctw**2*qdn*qmo*t
     & s/us**2*mw**2*mmo+2*ctw**2*qdn*qmo*ts/us**2*mmo**3+2*ctw**2*qdn*q
     & mo*ts/us*mmo+ctw**2*qdn*qmo*ts**2/us**2*mmo-2*ctw**2*qdn*qmo/us**
     & 2*mw**2*mmo**3+ctw**2*qdn*qmo/us**2*mw**4*mmo+ctw**2*qdn*qmo/us**
     & 2*mmo**5-3*ctw**2*qdn*qmo/us*mw**2*mmo+3*ctw**2*qdn*qmo/us*mmo**3
     & +ctw**2*qdn*qmo*mmo+qup*qmo/ts*us*mmo-qup*qmo/ts*mw**2*mmo+qup*qm
     & o/ts*mmo**3+qup*qmo*mmo+2*qdn*qmo*ts/us**2*mw**2*mmo-2*qdn*qmo*ts
     & /us**2*mmo**3-2*qdn*qmo*ts/us*mmo-qdn*qmo*ts**2/us**2*mmo+2*qdn*q
     & mo/us**2*mw**2*mmo**3-qdn*qmo/us**2*mw**4*mmo-qdn*qmo/us**2*mmo**
     & 5+3*qdn*qmo/us*mw**2*mmo-3*qdn*qmo/us*mmo**3-qdn*qmo*mmo)
     & +c0cctscwmo*(-2*ctw**2*qdn*qmo/ts/us**2*mw**2*mmo**5+ctw**2*qdn*q
     & mo/ts/us**2*mw**4*mmo**3+ctw**2*qdn*qmo/ts/us**2*mmo**7-ctw**2*qd
     & n*qmo/ts/us*mw**2*mmo**3+ctw**2*qdn*qmo/ts/us*mmo**5-2*ctw**2*qdn
     & *qmo*ts/us**2*mw**2*mmo+3*ctw**2*qdn*qmo*ts/us**2*mmo**3+ctw**2*q
     & dn*qmo*ts/us*mmo+ctw**2*qdn*qmo*ts**2/us**2*mmo-4*ctw**2*qdn*qmo/
     & us**2*mw**2*mmo**3+ctw**2*qdn*qmo/us**2*mw**4*mmo+3*ctw**2*qdn*qm
     & o/us**2*mmo**5-ctw**2*qdn*qmo/us*mw**2*mmo+2*ctw**2*qdn*qmo/us*mm
     & o**3+2*qdn*qmo/ts/us**2*mw**2*mmo**5-qdn*qmo/ts/us**2*mw**4*mmo**
     & 3-qdn*qmo/ts/us**2*mmo**7+qdn*qmo/ts/us*mw**2*mmo**3-qdn*qmo/ts/u
     & s*mmo**5+2*qdn*qmo*ts/us**2*mw**2*mmo-3*qdn*qmo*ts/us**2*mmo**3-q
     & dn*qmo*ts/us*mmo-qdn*qmo*ts**2/us**2*mmo+4*qdn*qmo/us**2*mw**2*mm
     & o**3-qdn*qmo/us**2*mw**4*mmo-3*qdn*qmo/us**2*mmo**5+qdn*qmo/us*mw
     & **2*mmo-2*qdn*qmo/us*mmo**3)
     & +c0ccuscwmo*(ctw**2*qup*qmo/qs/us*mw**2*mmo**3+ctw**2*qup*qmo/qs*
     & mw**2*mmo+ctw**2*qup*qmo/ts/us*mw**2*mmo**3-ctw**2*qup*qmo/ts/us*
     & mmo**5-ctw**2*qup*qmo/ts*us*mmo+ctw**2*qup*qmo/ts*mw**2*mmo-2*ctw
     & **2*qup*qmo/ts*mmo**3-qup*qmo/qs/us*mw**2*mmo**3-qup*qmo/qs*mw**2
     & *mmo-qup*qmo/ts/us*mw**2*mmo**3+qup*qmo/ts/us*mmo**5+qup*qmo/ts*u
     & s*mmo-qup*qmo/ts*mw**2*mmo+2*qup*qmo/ts*mmo**3)

      ff_ew_rd =
     & 0

      ffarray(1,1) = ff_ew_ll
      ffarray(1,2) = ff_ew_ld
      ffarray(1,3) = ff_ew_rd

      return
      end
